import Router from 'next/router';
import { ofType } from 'redux-observable';
import { concat, of } from 'rxjs';
import { switchMap } from 'rxjs/operators';

import { GET_ITEM } from '@/graphql/services/customReports/constants';
import { TYPE_ERROR } from '@/modules/@common/notify/constants';

import { PAYLOAD_NAME } from '@/graphql/services/customReports/types/payload/item';

import { getItemAction, setAction } from '../slices';
import { gqlRequest } from '@/modules/@common/request';
import { showNotificationAction } from '@/modules/layout/redux/slices';

const query = `
  query ${GET_ITEM}($payload: ${PAYLOAD_NAME}) {
    ${GET_ITEM}(payload: $payload) {
      id
      account {
        id
        name
        publishers {
          id
          name
        }
      }
      allSites
      uiName
      enabled
      description
      lookerReportId
      publisherIds
      icon
    }
  }
`;

const getResponse = ({ data }) => data[GET_ITEM];

export default (action$) =>
  action$.pipe(
    ofType(getItemAction.type),
    switchMap((action) => {
      const stream$ = gqlRequest(
        {
          query,
          variables: {
            payload: {
              id: action.payload.id,
            },
          },
        },
        {
          showNotificationMessage: false,
        },
      ).pipe(
        switchMap((response) => {
          const actions = [];

          if (response.errors.length) {
            actions.push(
              of(
                showNotificationAction({
                  type: TYPE_ERROR,
                  message: "Can't open dashboard for edit",
                }),
              ),
            );

            Router.push('/custom-reports');
          } else {
            const data = getResponse(response);

            actions.push(of(setAction(data)));
          }

          return concat(...actions);
        }),
      );

      return concat(stream$);
    }),
  );
